unit Childwin;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Mltlang, Textlist, Msgfrm, Buttons, Dialogs, Spin;

type
  TMDIChild = class(TForm)
    TextList1: TTextList;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    Label1: TLabel;
    MltLang1: TMltLang;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MltLang1BeforeChanging(Sender: TObject;
      var Allowed: Boolean);
    procedure MltLang1LanguageChanged(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateCmp;
  end;

implementation

{$R *.DFM}


procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.MltLang1BeforeChanging(Sender: TObject;
  var Allowed: Boolean);
begin
  if CheckBox1.checked then
       Allowed := false;
end;

procedure TMDIChild.MltLang1LanguageChanged(Sender: TObject);
begin
  UpdateCmp;
end;

procedure TMDIChild.UpdateCmp;
var
  i: Integer;
begin
  for i := 0 to ListBox1.Items.Count-1 do
       ListBox1.Items[i] := TextList1.Items[i];
end;

procedure TMDIChild.FormActivate(Sender: TObject);
begin
  UpdateCmp;
end;

procedure TMDIChild.BitBtn1Click(Sender: TObject);
begin
    { demonstrates the use of TTextList for global messages }
    MessageDlg(msgGetMessage(SpinEdit1.Value), mtConfirmation, mbYesNoCancel, 0);
end;

end.
